<?php
/*
Plugin Name: Massejli WA

Plugin URI: http://wordpress.org/plugins/massejli-wa/
Description: Full WhatsApp solution integration. WhatsApp Chat widget. WhatsApp bot. Send posts automatically to WhatsApp when published or updated, whether to Groups, or private chat, with  control in text size, url and media attachment. Get notifications in WhatsApp when somone contact you in Contact Form 7. Get shopping cart info in WhatsApp when customer shop in your WooCommerce store. To get started: activate the Massejli WA plugin and then go to your Massejli WA Settings page to set up your API BBS key and Nickname.
Author: Massejli
Version: 1.0
Author URI: http://Massej.li
*/

if ( ! defined( 'ABSPATH' ) ) {
	die( 'Invalid request.' );
}

if(get_bloginfo("language") == "ar" ){
    include plugin_dir_path( __FILE__ ) . './i18n/ar.php';
}
else{
    include plugin_dir_path( __FILE__ ) . './i18n/en.php';
}
/*
if(is_rtl()){

    $msjli_dir = "rtl";
}
else{
    $msjli_dir =  "ltr";
}
*/
require(plugin_dir_path( __FILE__ ) . './msjli_functions.php');
require(plugin_dir_path( __FILE__ ) . './msjli_publish_post.php');
require(plugin_dir_path( __FILE__ ) . './msjli_activate.php');
require(plugin_dir_path( __FILE__ ) . './msjli_widget.php');
require(plugin_dir_path( __FILE__ ) . './msjli_login.php');

add_action( 'admin_head', 'msjli_posts_css_js' );
add_action( 'admin_menu', 'msjli_my_menu_pages');
add_action( 'add_meta_boxes', 'msjli_add_custom_meta_box');
add_action( 'save_post', 'msjli_publish_post', 10, 2 );
add_action( 'new_to_publish', 'msjli_publish_post', 10, 2 );
add_action( 'admin_notices', 'general_admin_notice');

add_action('init', 'msjli_wp_login');

$plugin = plugin_basename(__FILE__);
add_filter("plugin_action_links_$plugin", 'msjli_wa_settings_link' );

include_once( ABSPATH . 'wp-admin/includes/plugin.php' );
if ( is_plugin_active('contact-form-7/wp-contact-form-7.php') ) {
    require(plugin_dir_path( __FILE__ ) . './msjli_contact_form7.php');
}
if ( is_plugin_active('woocommerce/woocommerce.php') ) {
    require(plugin_dir_path( __FILE__ ) . './msjli_woocommerce.php');
}


// image for grouped items in woocommerce
add_action( 'woocommerce_grouped_product_list_after_quantity', 'wc_grouped_product_thumbnail' );
  
function wc_grouped_product_thumbnail( $product ) {
    $image_size = array( 120, 120 );
    $attachment_id = get_post_meta( $product->get_id(), '_thumbnail_id', true, array( "class" => "img-responsive" ) );
    $link = get_the_permalink( $product->get_id() );
    ?>
    <td style="margin:0px !important; padding:0px !important; width:100px !important;">
        <a href="<?php echo $link; ?>" > <?php echo wp_get_attachment_image( $attachment_id, $image_size ); ?> </a>
    </td>
    <?php
}
?>
