<?php
if ( ! defined( 'ABSPATH' ) ) {
	die( 'Invalid request.' );
}

add_action('woocommerce_order_status_changed', 'msjli_woo_order_status_change', 10, 3);
add_action('woocommerce_thankyou', 'msjli_woo_new_order', 10, 1);

add_action( 'woocommerce_order_actions', 'mjli_woo_order_actions' );
function mjli_woo_order_actions( $actions ) {
    $actions['resend_order_processing_whatsapp'] =  msjli_Resend_Order_WhatsApp_Message;
    return $actions;
}
add_action( 'woocommerce_order_action_resend_order_processing_whatsapp', 'mjli_woo_resend_order_processing_whatsapp' );
function mjli_woo_resend_order_processing_whatsapp( $order ) {
    $order_id = $order->get_id();
		update_post_meta( $order_id, 'msjli_woo_wa_sent', False );
		msjli_woo_pos_new_order($order_id);
    $order->add_order_note( msjli_Order_message_WhatsApp_Resent);
}


add_filter( 'get_comment_author', 'wpse_get_rid_of_comment_author' );

function wpse_get_rid_of_comment_author( $name ) {

   $name = substr($name,0,strlen($name)-3) ;

	return msjli_client."***".$name;

}

add_action('before_delete_post', function($id) { // report admin on delete order
    $post_type = get_post_type($id);

    if ($post_type !== 'shop_order') {
        return;
    }

	$message = "Order details: <br/>";

	$order = new WC_Order($id);
	$order_data = $order->get_data(); // The Order data
	$message .= 'Order date created: '.$order_data['date_created']->date('d-m-Y H:i:s'). "<br/>";
	$message .= 'Order date modified: '.$order_data['date_modified']->date('d-m-Y H:i:s'). "<br/>";
	$message .='Order total: <strong>'.$order_data['total']. "</strong><br/>";
	$message .= 'Order customer id: '. $order_data['customer_id']. "<br/>";
	$message .= 'First name: '. $order_data['billing']['first_name']. "<br/>";
	$message .= 'Last name: '.$order_data['billing']['last_name']. "<br/>";
	$message .= '<br/>--------------------<br/>';
	if ( is_user_logged_in() ) {  // The sales man data
		global $current_user;
		get_currentuserinfo();
		$message .= '<br/><br/>Delete Action by:<br/>';
		$message .= 'User ID: ' . $current_user->ID . "<br/>";
		$message .= 'User first name: ' . $current_user->user_firstname . "<br/>";
		$message .= 'User last name: ' . $current_user->user_lastname . "<br/>";
		$message .= 'User display name: ' . $current_user->display_name . "<br/>";
		$message .= 'Username: <strong>' . $current_user->user_login . "</strong><br/>";
		$message .= 'User email: ' . $current_user->user_email . "<br/>";
	 }


	$admin_email = get_option( 'admin_email' );
	$subject = "Warning, Order deleted #".$id;
	$heading = "Order Deleted";

	send_email_woocommerce_style($admin_email, $subject, $heading, $message);
    //msjli_woo_order_status_change( $id, "not_deleted", "deleted" );

}, 10, 1);

// Make zip/postcode field optional
add_filter( 'woocommerce_default_address_fields' , 'msjli_optional_postcode_checkout' );


function msjli_optional_postcode_checkout( $p_fields ) {
	$p_fields['postcode']['required'] = false;
	return $p_fields;
}

function msjli_woo_pos_new_order($order_id) {

		//check if this order wassent via WA
		$order = wc_get_order($order_id);
		$order_info = array();
		$user_id   = $order->get_user_id(); // Get the costumer ID
		$order_id  = $order->get_id(); // Get the order ID
		$msjli_woo_wa_sent = get_post_meta( $order_id, 'msjli_woo_wa_sent', true);
		$billing_phone = get_user_meta( $user_id, 'billing_phone', true );
		$billing_phone = msjli_correct_wa_number($billing_phone);

		if(empty($msjli_woo_wa_sent)){
			update_user_meta( $user_id, 'billing_phone', $billing_phone );
	    $msjli_service_number = get_option( 'msjli_service_number' );
	    $msjli_bbs_key = get_option( 'msjli_bbs_key' );
	    $msjli_nickname = get_option( 'msjli_nickname' );

	    $msjli_woocommerce_list_numbers = str_replace("\r",'', get_option( 'msjli_woocommerce_list_numbers' )); // sometimes textarea use \r\n for newlines
	    $msjli_woocommerce_list_numbers = validate_list_numbers($msjli_woocommerce_list_numbers);

	    $message  = msjli_get_order_info_wa_formated($order_id,False);
	    //$message .= msjli_get_user_info_wa_formated();
	    //$message .=  msjli_get_address_wa_formated($user_id);
	    $post_date = date('Y-m-d H:i:s');
	    $post_publish_date = get_the_time('Y-m-d H:i:s', $order_id);
	    $message .= '%2B'.$billing_phone. "\n__________________________\n".$post_date ."\n\npowered by:\nmassejli.com";

	    #if the user enter his phone number and its a valid phone we will send him notification too

	    if($billing_phone){
	        $billing_phone = str_replace("+","",(int)$billing_phone);
	        if(valid_phone_number($billing_phone)){
	            $msjli_woocommerce_list_numbers .= "\n".$billing_phone;
	            $message .=  "\n\n🙂 ".msjli_woocommerce_thanks_for_order;
	        }
	    }

		//	file_put_contents( dirname( __FILE__ )."/numbers_list.txt" , $msjli_woocommerce_list_numbers ,FILE_APPEND );

	    if(get_option('msjli_woocommerce_check') == 'true'){
	        $message_data =
	            array(
	                "op"=> "publish_message",
	                "bbs" => $msjli_bbs_key,
	                "nickname"=> $msjli_nickname,
	                "data"=> array(
	                            "link" => "",
	                            "category" => "",
	                            "title" => msjli_woocommerce_wa_title,
	                            "message" => $message,
	                            "photo" => "",
	                            "video" => "",
	                            "audio" => "",
	                            "document" => "",
	                            "youtube" => "",
	                            "list" => $msjli_woocommerce_list_numbers,// we will use only list of numbers , not all contact list
	                            "service_numbers" => $msjli_service_number,
	                            "send_to_groups" => false,
	                            "send_to_contacts" => false,
	                            "use_template" => false,
	                            "message_gmt_date_time" => $post_date ,
	                            "message_date_time" => $post_publish_date,
	                            "wa_options" =>array("groups"=>array("type"=> "2","length"=>""),"private"=>array("type"=>"2","length"=>"")),
	                            "private" => array("type"=> "2","length"=>"")),
	            );
	        #file_put_contents(dirname( __FILE__ )."/msjli_cf7_check.txt",json_encode($message_data));
	        msjli_contactform_to_whatsapp($message_data,$msjli_bbs_key);

					$taxonomy     = 'product_cat';
					$orderby      = 'name';
					$show_count   = 0;      // 1 for yes, 0 for no
					$pad_counts   = 0;      // 1 for yes, 0 for no
					$hierarchical = 1;      // 1 for yes, 0 for no
					$title        = '';
					$empty        = 0;

					$args = array(
								 'taxonomy'     => $taxonomy,
								 'orderby'      => $orderby,
								 'show_count'   => $show_count,
								 'pad_counts'   => $pad_counts,
								 'hierarchical' => $hierarchical,
								 'title_li'     => $title,
								 'hide_empty'   => $empty
					);

					//send message to category wa number
				 $all_categories = get_categories( $args );
				 foreach ($all_categories as $cat) {
						if($cat->category_parent == 0) {
								//$category_id = $cat->term_id;
								$cat_wa_number = get_option($cat->slug);
								if($cat_wa_number){
									$cat_message = msjli_get_categories_order_info_wa_formated($order_id,$cat->slug,$cat->name);

									$order_data = $order->get_data();
									$last_name = '';
									if(trim($order_data['billing']['last_name'])){
										$last_name = " ".trim($order_data['billing']['last_name']);
									}

							    $client_name = " *".trim($order_data['billing']['first_name']).$last_name."* ";

									if($cat_message){
										$cat_message .= $msjli_get_user_info_wa_formated ;
										$cat_message .= "👤".$client_name ."\n".$billing_phone. "\n__________________________\n". date('Y-m-d H:i:s');

										$message_data =
											 array(
													 "op"=> "publish_message",
													 "bbs" => $msjli_bbs_key,
													 "nickname"=> $msjli_nickname,
													 "data"=> array(
																			 "link" => "",
																			 "category" => "",
																			 "title" => msjli_woocommerce_wa_title,
																			 "message" => $cat_message,
																			 "photo" => "",
																			 "video" => "",
																			 "audio" => "",
																			 "document" => "",
																			 "youtube" => "",
																			 "list" => $cat_wa_number,// we will use only list of numbers , not all contact list
																			 "service_numbers" => $msjli_service_number,
																			 "send_to_groups" => false,
																			 "send_to_contacts" => false,
																			 "use_template" => false,
																			 "message_gmt_date_time" => $post_date ,
																			 "message_date_time" => "",
																			 "wa_options" =>array("groups"=>array("type"=> "2","length"=>""),"private"=>array("type"=>"2","length"=>"")),
																			 "private" => array("type"=> "2","length"=>"")),
											 );
									 msjli_contactform_to_whatsapp($message_data,$msjli_bbs_key);
									}

							}
						}
					}

					update_post_meta( $order_id, 'msjli_woo_wa_sent', 'yes' );

			}
		}
		else{
			update_user_meta( $user_id, 'billing_phone', $billing_phone );
		}
}


function msjli_woo_new_order($order_id) {

		$order = wc_get_order($order_id);
		$order_info = array();
		$user_id   = $order->get_user_id(); // Get the costumer ID
		$order_id  = $order->get_id(); // Get the order ID
		$msjli_woo_wa_sent = get_post_meta( $order_id, 'msjli_woo_wa_sent', true);
		$billing_phone = get_user_meta( $user_id, 'billing_phone', true );
		$billing_phone = msjli_correct_wa_number($billing_phone);

		if(empty($msjli_woo_wa_sent)){ 	//check if this order was sent via WA
			update_user_meta( $user_id, 'billing_phone', $billing_phone );
	    $msjli_service_number = get_option( 'msjli_service_number' );
	    $msjli_bbs_key = get_option( 'msjli_bbs_key' );
	    $msjli_nickname = get_option( 'msjli_nickname' );

	    $msjli_woocommerce_list_numbers = str_replace("\r",'', get_option( 'msjli_woocommerce_list_numbers' )); // sometimes textarea use \r\n for newlines
	    $msjli_woocommerce_list_numbers = validate_list_numbers($msjli_woocommerce_list_numbers);

	    $message  = msjli_get_order_info_wa_formated($order_id,True);
	    $msjli_get_user_info_wa_formated = msjli_get_user_info_wa_formated();
	    $message .= $msjli_get_user_info_wa_formated ;
	    $msjli_get_address_wa_formated=  msjli_get_address_wa_formated($user_id);
	    $message .=  $msjli_get_address_wa_formated;
	    $post_date = date('Y-m-d H:i:s');
	    $message .= "__________________________\n".$post_date ."\n\npowered by:\nmassejli.com";

	    #if the user enter his phone number and its a valid phone we will send him notification too

	    if($billing_phone){
	        $billing_phone = str_replace("+","",(int)$billing_phone);
	        if(valid_phone_number($billing_phone)){
	            $msjli_woocommerce_list_numbers .= "\n".$billing_phone;
	            $message .=  "\n\n🙂".msjli_woocommerce_thanks_for_order;
	        }
	    }

		//	file_put_contents( dirname( __FILE__ )."/numbers_list.txt" , $msjli_woocommerce_list_numbers ,FILE_APPEND );

	    if(get_option('msjli_woocommerce_check') == 'true'){
	        $message_data =
	            array(
	                "op"=> "publish_message",
	                "bbs" => $msjli_bbs_key,
	                "nickname"=> $msjli_nickname,
	                "data"=> array(
	                            "link" => "",
	                            "category" => "",
	                            "title" => msjli_woocommerce_wa_title,
	                            "message" => $message,
	                            "photo" => "",
	                            "video" => "",
	                            "audio" => "",
	                            "document" => "",
	                            "youtube" => "",
	                            "list" => $msjli_woocommerce_list_numbers,// we will use only list of numbers , not all contact list
	                            "service_numbers" => $msjli_service_number,
	                            "send_to_groups" => false,
	                            "send_to_contacts" => false,
	                            "use_template" => false,
	                            "message_gmt_date_time" => $post_date ,
	                            "message_date_time" => "",
	                            "wa_options" =>array("groups"=>array("type"=> "2","length"=>""),"private"=>array("type"=>"2","length"=>"")),
	                            "private" => array("type"=> "2","length"=>"")),
	            );
	        #file_put_contents(dirname( __FILE__ )."/msjli_cf7_check.txt",json_encode($message_data));
	        msjli_contactform_to_whatsapp($message_data,$msjli_bbs_key);

					 $taxonomy     = 'product_cat';
					 $orderby      = 'name';
					 $show_count   = 0;      // 1 for yes, 0 for no
					 $pad_counts   = 0;      // 1 for yes, 0 for no
					 $hierarchical = 1;      // 1 for yes, 0 for no
					 $title        = '';
					 $empty        = 0;

					 $args = array(
									'taxonomy'     => $taxonomy,
									'orderby'      => $orderby,
									'show_count'   => $show_count,
									'pad_counts'   => $pad_counts,
									'hierarchical' => $hierarchical,
									'title_li'     => $title,
									'hide_empty'   => $empty
					 );

					 //send message to category wa number
					$all_categories = get_categories( $args );
					foreach ($all_categories as $cat) {
						 if($cat->category_parent == 0) {
								 //$category_id = $cat->term_id;
								 $cat_wa_number = get_option($cat->slug);
								 if($cat_wa_number){
									 $cat_message = msjli_get_categories_order_info_wa_formated($order_id,$cat->slug,$cat->name);
									 if($cat_message){
										 $cat_message .= $msjli_get_user_info_wa_formated . date('Y-m-d H:i:s');
										 $message_data =
												array(
														"op"=> "publish_message",
														"bbs" => $msjli_bbs_key,
														"nickname"=> $msjli_nickname,
														"data"=> array(
																				"link" => "",
																				"category" => "",
																				"title" => msjli_woocommerce_wa_title,
																				"message" => $cat_message,
																				"photo" => "",
																				"video" => "",
																				"audio" => "",
																				"document" => "",
																				"youtube" => "",
																				"list" => $cat_wa_number,// we will use only list of numbers , not all contact list
																				"service_numbers" => $msjli_service_number,
																				"send_to_groups" => false,
																				"send_to_contacts" => false,
																				"use_template" => false,
																				"message_gmt_date_time" => $post_date ,
																				"message_date_time" => "",
																				"wa_options" =>array("groups"=>array("type"=> "2","length"=>""),"private"=>array("type"=>"2","length"=>"")),
																				"private" => array("type"=> "2","length"=>"")),
												);
										msjli_contactform_to_whatsapp($message_data,$msjli_bbs_key);
									 }

							 }
						 }
					 }

					update_post_meta( $order_id, 'msjli_woo_wa_sent', 'yes' );
	    }
		}
		else{
			update_user_meta( $user_id, 'billing_phone', $billing_phone );
		}
}


//order status change
function msjli_woo_order_status_change( $order_id, $old_status, $new_status ){

		if ( $old_status == "pending"  && $new_status == "processing" ){
				return true;
		}

		$msli_cat_wa_numbers = "\n";
		if($new_status == "cancelled"){ // send wa to categories numbers
				 $taxonomy     = 'product_cat';
				 $orderby      = 'name';
				 $show_count   = 0;      // 1 for yes, 0 for no
				 $pad_counts   = 0;      // 1 for yes, 0 for no
				 $hierarchical = 1;      // 1 for yes, 0 for no
				 $title        = '';
				 $empty        = 0;

				 $args = array(
								'taxonomy'     => $taxonomy,
								'orderby'      => $orderby,
								'show_count'   => $show_count,
								'pad_counts'   => $pad_counts,
								'hierarchical' => $hierarchical,
								'title_li'     => $title,
								'hide_empty'   => $empty
				 );
				 $order = "";
				 $order = wc_get_order( $order_id );
				 $all_categories = get_categories( $args );

				 foreach ($all_categories as $cat) {
						if($cat->category_parent == 0) {
								$cat_wa_phone = get_option($cat->slug);
								if($cat_wa_phone){
									$category = $cat->slug;
									foreach ($order->get_items() as $item_key => $item ):
											$product_id   = $item->get_product_id();
											if( has_term( $category, 'product_cat',$product_id ) ) {
													$msli_cat_wa_numbers .= $cat_wa_phone ."\n";
											}
									endforeach;
								}
						}
					}
		}

    $msjli_service_number = get_option( 'msjli_service_number' );
    $msjli_bbs_key = get_option( 'msjli_bbs_key' );
    $msjli_nickname = get_option( 'msjli_nickname' );

    $msjli_woocommerce_list_numbers = str_replace("\r",'', get_option( 'msjli_woocommerce_list_numbers' )); // sometimes textarea use \r\n for newlines
		$msjli_woocommerce_list_numbers .= $msli_cat_wa_numbers;
		$msjli_woocommerce_list_numbers = validate_list_numbers($msjli_woocommerce_list_numbers);
    $post_date = date('Y-m-d H:i:s');

    $order = wc_get_order( $order_id );
    $order_data = $order->get_data(); // The Order data

    $message = "#". $order_data['number'] . "  ".$order_data['billing']['first_name']." ".$order_data['billing']['last_name']." \n";

		if(constant($old_status)){
			$message .= msjli_woocommerce_order_old_status.": ".constant($old_status) ."\n\n";
		}
		$message .= $post_date  ." GMT \n";
    $message .= "*".msjli_woocommerce_order_new_status.": ".constant($new_status)."*";

    $order = wc_get_order($order_id);
    $user_id   = $order->get_user_id(); // Get the costumer ID
    #if the user enter his phone number and its a valid phone we will send him notification too
    $billing_phone = get_user_meta( $user_id, 'billing_phone', true );
    if($billing_phone){
        $billing_phone = str_replace("+","",(int)$billing_phone);
        if(valid_phone_number($billing_phone)){
					if($new_status != "completed"){
						$msjli_woocommerce_list_numbers .= "\n".$billing_phone;
					}
        }
    }

    if(get_option('msjli_woocommerce_check') == 'true'){

			if($new_status == "completed"){

				msjli_woo_pos_new_order($order_id);

				$order_source = get_post_meta($order_id,'_op_order_source',true);
				file_put_contents( dirname( __FILE__ )."/act.txt", json_encode($order_source) );

				if($order_source == "openpos"){
					return true; // POS order don't need notifcation about change status
				}
				$emo_arr = array( "😀","😃","😃","🙃","😉","😊","😇","🥰	","🤩","☺️","🤭");
				$ky = array_rand( $emo_arr);
				$r_emoji = ($emo_arr[$ky]);
				$cust_message = thanks_for_your_shopping."https://wa.me/".$msjli_service_number.' '.$r_emoji;
				$cust_message .= "\n\n".review_product_and_delivery.":\n".$_SERVER['SERVER_NAME'].'/my-account/view-order/'.$order_id ;
				$message_data =
						array(
								"op"=> "publish_message",
								"bbs" => $msjli_bbs_key,
								"nickname"=> $msjli_nickname,
								"data"=> array(
														"link" => "",
														"category" => "",
														"title" => "",
														"message" => $cust_message,
														"photo" => "",
														"video" => "",
														"audio" => "",
														"document" => "",
														"youtube" => "",
														"list" => $billing_phone,// we will use only list of numbers , not all contact list
														"service_numbers" => $msjli_service_number,
														"send_to_groups" => false,
														"send_to_contacts" => false,
														"use_template" => false,
														"message_gmt_date_time" => $post_date ,
														"message_date_time" => "",
														"wa_options" =>array("groups"=>array("type"=> "2","length"=>""),"private"=>array("type"=>"2","length"=>"")),
														"private" => array("type"=> "2","length"=>"")),
						);
				// thanks customer for purchase
				msjli_contactform_to_whatsapp($message_data,$msjli_bbs_key);
				}

        $message_data =
            array(
                "op"=> "publish_message",
                "bbs" => $msjli_bbs_key,
                "nickname"=> $msjli_nickname,
                "data"=> array(
                            "link" => "",
                            "category" => "",
                            "title" => msjli_woocommerce_order_status_changed,
                            "message" => $message,
                            "photo" => "",
                            "video" => "",
                            "audio" => "",
                            "document" => "",
                            "youtube" => "",
                            "list" => $msjli_woocommerce_list_numbers,// we will use only list of numbers , not all contact list
                            "service_numbers" => $msjli_service_number,
                            "send_to_groups" => false,
                            "send_to_contacts" => false,
                            "use_template" => false,
                            "message_gmt_date_time" => $post_date ,
                            "message_date_time" => "",
                            "wa_options" =>array("groups"=>array("type"=> "2","length"=>""),"private"=>array("type"=>"2","length"=>"")),
                            "private" => array("type"=> "2","length"=>"")),
            );
        #file_put_contents(dirname( __FILE__ )."/msjli_cf7_check.txt",json_encode($message_data));
        msjli_contactform_to_whatsapp($message_data,$msjli_bbs_key);
    }
}

function msjli_get_categories_order_info_wa_formated($order_id,$category,$category_name){

    // Get an instance of the WC_Order object
		$order = "";
    $order = wc_get_order( $order_id );
    $order_data = $order->get_data(); // The Order data
    $order_currency = $order_data['currency'];

    $order_info = "";
		$last_name = '';
		if(trim($order_data['billing']['last_name'])){
			$last_name = " ".trim($order_data['billing']['last_name']);
		}

    $order_info .= "🛒 *#". trim($order_data['number']) . "*  ".$category_name." \n\n";
    $subtotal = 0;
    $total_subtotal = 0;
		$items_count = 0;
    // Iterating through each WC_Order_Item_Product objects
    foreach ($order->get_items() as $item_key => $item ):

        // Item ID is directly accessible from the $item_key in the foreach loop
        $item_id = $item->get_id();
        ## Using WC_Order_Item_Product methods ##
        $product      = $item->get_product(); // Get the WC_Product object
        $product_id   = $item->get_product_id(); // the Product id
        $variation_id = $item->get_variation_id(); // the Variation id

				if( has_term( $category, 'product_cat',$product_id ) ) {
					//echo $product_id .' chips <br/>';
					// Check if product has variation.
					if ($variation_id) {
						$product = new WC_Product($variation_id);
					} else {
						$product = new WC_Product($product_id);
					}
					$sku = $product->get_sku();
					$order_info .= "*" .$item->get_name() ."* × " .$item->get_quantity()." \n" ;
					if($sku){
						$order_info .= msjli_woocommerce_payment_sku.": ".$sku ." \n";
					}
					$subtotal  = round($item->get_subtotal(),2) ;
					$total_subtotal += $subtotal;
					$order_info .= $subtotal ." ".$order_currency ." \n\n";
					$items_count ++;
				}

    endforeach;

    if($order_data['customer_note']){
    	$note_data = trim($order_data['customer_note']);
    	$note_data = str_replace(array("\n", "\r"), ' ', $note_data);
        $order_info .= msjli_woocommerce_customer_note.": \n*".$note_data."*\n\n";
    }

		$order_info .= msjli_woocommerce_subtotal.": ".$total_subtotal." ".$order_currency."\n";

		if($order_data['cart_tax']){
    	$order_info .= msjli_woocommerce_tax.": ".$order_data['cart_tax']." ".$order_currency."\n";
    }

		$payment_method = $order_data['payment_method_title'];
		if(defined($order_data['payment_method_title'])){
			$payment_method = constant($order_data['payment_method_title']);
		}
		$order_info .= "\n".msjli_woocommerce_payment_method.": \n".$payment_method."\n\n";
    $order_info .= "__________________________\n\n";

		if($items_count){
			return $order_info ;
		}
		else {
			return false;
		}

}

function msjli_get_order_info_wa_formated($order_id,$show_shipment){

    // Get an instance of the WC_Order object
		$order = "";
    $order = wc_get_order( $order_id );
    $order_data = $order->get_data(); // The Order data
    $order_currency = $order_data['currency'];

    $order_info = "";
		$last_name = '';
		if(trim($order_data['billing']['last_name'])){
			$last_name = " ".trim($order_data['billing']['last_name']);
		}

    $order_info .= "🛒 *#". trim($order_data['number']) . "  ".trim($order_data['billing']['first_name']).$last_name."* \n\n";
    $subtotal = 0;
    $total_subtotal = 0;
    // Iterating through each WC_Order_Item_Product objects
    foreach ($order->get_items() as $item_key => $item ):

        // Item ID is directly accessible from the $item_key in the foreach loop
        $item_id = $item->get_id();
        ## Using WC_Order_Item_Product methods ##
        $product      = $item->get_product(); // Get the WC_Product object
        $product_id   = $item->get_product_id(); // the Product id
        $variation_id = $item->get_variation_id(); // the Variation id
        // Check if product has variation.
        if ($variation_id) {
        	$product = new WC_Product($variation_id);
        } else {
        	$product = new WC_Product($product_id);
        }
        $sku = $product->get_sku();
        $order_info .= "*" .$item->get_name() ."* × " .$item->get_quantity()." \n" ;
        if($sku){
        	$order_info .= msjli_woocommerce_payment_sku.": ".$sku ." \n";
        }
        $subtotal  = round($item->get_subtotal(),2) ;
        $total_subtotal += $subtotal;
        $order_info .= $subtotal ." ".$order_currency ." \n\n";

    endforeach;

    if($order_data['customer_note']){
    	$note_data = trim($order_data['customer_note']);
    	$note_data = str_replace(array("\n", "\r"), ' ', $note_data);
        $order_info .= msjli_woocommerce_customer_note.": \n*".$note_data."*\n\n";
    }

	$order_shipment = $order->get_total_shipping() ;

	 if($show_shipment or $order_shipment){
		 $order_info .= msjli_woocommerce_delivery_cost.": ".$order_shipment." ".$order_currency."\n";
	 }

	if($order_data['total'] <> ($total_subtotal +  $order_shipment)){
		$order_info .= msjli_woocommerce_subtotal.": ".$total_subtotal." ".$order_currency."\n";
		$discount =  $order_data['total'] - ($total_subtotal+$order_shipment);
		$order_info .= msjli_woocommerce_discount.": ".$discount." ".$order_currency."\n";
	}

	if($order_data['cart_tax']){
    	$order_info .= msjli_woocommerce_tax.": ".$order_data['cart_tax']." ".$order_currency."\n";
    }

    $order_info .= "*".msjli_woocommerce_payment_total.": ".$order_data['total']." ".$order_currency."*\n";

		$payment_method = $order_data['payment_method_title'];
		if(defined($order_data['payment_method_title'])){
			$payment_method = constant($order_data['payment_method_title']);
		}
		$order_info .= "\n".msjli_woocommerce_payment_method.": \n".$payment_method."\n\n";
    $order_info .= "__________________________\n\n";
    return $order_info ;
}

function msjli_get_user_info_wa_formated(){

    $current_user = wp_get_current_user();

    if ( ! ( $current_user instanceof WP_User ) ) {
        return;
    }
    $user_info = "*👤 ".user_info."*: \n\n";
    $user_info .= $current_user->user_firstname . ' '.$current_user->user_lastname."\n %2B" . $current_user->user_login ;
    //$user_info .= "\n\n";
    //$user_info .= "User email:\n". $current_user->user_email ;
    //$user_info .= "\n";
    //$user_info .= get_author_posts_url(get_current_user_id() );
    $user_info .= "\n__________________________\n\n";
    return $user_info;

}

function msjli_get_address_wa_formated($user_id) {

	$address ="";
/*
    $address .= '*🏦 '.billing_address."* \n\n";

    $billing_first_name = get_user_meta( $user_id, 'billing_first_name', true );
    if($billing_first_name){
        $address .= first_name .": \n*" . $billing_first_name.'*';
        $address .= "\n";
    }
    $billing_last_name = get_user_meta( $user_id, 'billing_last_name', true );
    if($billing_last_name){
        $address .= last_name .": \n*" . $billing_last_name.'*';
        $address .= "\n";
    }
    $billing_company = get_user_meta( $user_id, 'billing_company', true );
    if($billing_company){
        $address .= company .": \n*" . $billing_company.'*';
        $address .= "\n";
    }
    $billing_address_1 = get_user_meta( $user_id, 'billing_address_1', true );
    if($billing_address_1){
        $address .= address_1 .": \n*" .$billing_address_1.'*' ;
        $address .= "\n";
    }
    $billing_address_2 = get_user_meta( $user_id, 'billing_address_2', true );
    if($billing_address_2){
        $address .= address_2 .": \n*" . $billing_address_2.'*';
        $address .= "\n";
    }
    $billing_city = get_user_meta( $user_id, 'billing_city', true );
    if($billing_city){
        $address .= city .": \n*" . $billing_city.'*' ;
        $address .= "\n";
    }
    $billing_postcode = get_user_meta( $user_id, 'billing_postcode', true );
    if($billing_postcode){
        $address .= postcode .": \n*" . $billing_postcode.'*' ;
        $address .= "\n";
    }
    $billing_country = get_user_meta( $user_id, 'billing_country', true );
    if($billing_country){
        $address .= country .": \n*" . WC()->countries->countries[$billing_country] .'*';
        $address .= "\n";
    }
    $billing_email = get_user_meta( $user_id, 'billing_email', true );
    if($billing_email){
        //$address .= email .": \n*" . $billing_email.'*';
        //$address .= "\n";
    }
    $billing_phone =  get_user_meta( $user_id, 'billing_phone', true );
    $wa_link = "";
    if($billing_phone){
		$billing_phone = msjli_correct_wa_number($billing_phone);
        $address .= phone .": \n%2B" . $billing_phone;
        //$billing_phone = str_replace("+","",(int)$billing_phone);
        $billing_phone = str_replace("+","",ltrim($billing_phone, "0"));// remove + AND 00 FROM Mobile number
        $wa_link = "\n\nwa.me/".$billing_phone;
    }
    $address .= $wa_link."\n__________________________\n\n";
*/
    $address .= '*📦 '.shipping_address."* \n\n";

    $shipping_first_name = get_user_meta( $user_id, 'shipping_first_name', true );
    if($shipping_first_name){
        $address .= first_name .": \n*" . $shipping_first_name.'*';
        $address .= "\n";
    }
    $shipping_last_name = get_user_meta( $user_id, 'shipping_last_name', true );
    if($shipping_last_name){
        $address .= last_name .": \n*" . $shipping_last_name.'*';
        $address .= "\n";
    }
    $shipping_company = get_user_meta( $user_id, 'shipping_company', true );
    if($shipping_company){
        $address .= company .": \n*" .$shipping_company.'*' ;
        $address .= "\n";
    }
    $shipping_address_1 = get_user_meta( $user_id, 'shipping_address_1', true );
    if($shipping_address_1){
        $address .= address_1 .": \n*" .$shipping_address_1.'*' ;
        $address .= "\n";
    }
    $shipping_address_2 = get_user_meta( $user_id, 'shipping_address_2', true );
    if($shipping_address_2){
        $address .= address_2 .": \n*" . $shipping_address_2.'*' ;
        $address .= "\n";
    }
    $shipping_city = get_user_meta( $user_id, 'shipping_city', true );
    if($shipping_city){
        $address .= city .": \n*" . $shipping_city.'*' ;
        $address .= "\n";
    }
    $shipping_postcode = get_user_meta( $user_id, 'shipping_postcode', true );
    if($shipping_postcode ){
        $address .= postcode .": \n*" . $shipping_postcode.'*' ;
        $address .= "\n";
    }
    $shipping_country = get_user_meta( $user_id, 'shipping_country', true );
    if($shipping_country){
        $address .= country .": \n*" .WC()->countries->countries[$shipping_country].'*' ;
        $address .= "\n";
    }
    $shipping_email = get_user_meta( $user_id, 'shipping_email', true );
    if($shipping_email){
        $address .= email .": \n*" .$shipping_email.'*' ;
        $address .= "\n";
    }

    #file_put_contents(dirname( __FILE__ )."/address.txt",json_encode($address));

    return $address;
}

?>
